=== debian/changelog ===
gmic (1.6.2.0-1build2) wily; urgency=medium

  * No-change rebuild against libopencv-highgui2.4v5

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 13 Aug 2015 03:58:38 +0000

gmic (1.6.2.0-1build1) wily; urgency=medium

  * No-change rebuild against libopenexr22.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Thu, 06 Aug 2015 12:28:17 +0200

gmic (1.6.2.0-1) unstable; urgency=medium

  * [418ea338] Merge tag 'upstream/1.6.2.0'
    Upstream version 1.6.2.0
  * [7044920b] Refreshing patches.
  * [1fde2913] Add libcv/libhighgui-dev as dependency.
  * [6fd0cdcb] Add libcurl-dev

 -- Bernd Zeimetz <bzed@debian.org>  Sun, 19 Apr 2015 14:08:46 +0200
