=== zart/include/Makefile ===
.PHONY: all

all:
	cd ..; make
