=== debian/control ===
--- 
+++ 
@@ -1,23 +1,19 @@
 Source: gmic
 Section: graphics
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Bernd Zeimetz <bzed@debian.org>
+Maintainer: Bernd Zeimetz <bzed@debian.org>
 Build-Depends: debhelper (>= 8.1.3),
  dpkg-dev (>= 1.16.0),
  dh-exec (>=0.3),
  libgimp2.0-dev (>= 2.4),
  libx11-dev, libxrandr-dev, libfftw3-dev | fftw3-dev,
- libopencv-core-dev,
- libopencv-highgui-dev,
- libopencv-objdetect-dev,
- libopencv-imgproc-dev,
+ libopencv-dev,
  libopenexr-dev,
  libqt4-dev,
  libilmbase-dev,
  libcv-dev,
  libhighgui-dev,
- libcurl-dev
+ libcurl4-openssl-dev
 Standards-Version: 3.9.4
 Homepage: http://gmic.sourceforge.net/
 Vcs-Git: git://anonscm.debian.org/collab-maint/gmic.git
